#include <bits/stdc++.h>


using namespace std; 
using pi = pair<int, int>; 
using ppi = pair<pi, int>; 


vector<ppi> combine(vector<ppi> & segments, vector<int> bad_now){
    int bad_ind = 0; 
    vector<ppi> ans; 

    for (ppi seg : segments){
        int last_ind = bad_ind; 
        while (last_ind < bad_now.size()){
            if (bad_now[bad_ind] > seg.first.second) break; 
            if (bad_now[bad_ind] < seg.first.first) {
                ans.push_back(ppi(pi(bad_now[bad_ind], bad_now[bad_ind]), 1)); 
                bad_ind++; 
            }
            last_ind++; 
        }

        int start = seg.first.first; 

        for (int i = bad_ind; i < last_ind; ++i){
            int vb = bad_now[i]; 
            ans.push_back(ppi(pi(start, vb - 1), seg.second)); 
            ans.push_back(ppi(pi(vb, vb), seg.second + 1)); 
            start = vb + 1; 
        }
        if (start <= seg.first.second)
            ans.push_back(ppi(pi(start, seg.first.second), seg.second)); 

        bad_ind = last_ind + 1; 
    }

    while (bad_ind < bad_now.size()){
        {
            ans.push_back(ppi(pi(bad_now[bad_ind], bad_now[bad_ind]), 1)); 
            bad_ind++; 
        }
    }

    return ans; 
}


vector<ppi> compress(vector<ppi> & segments){
    vector<ppi> ans; 
    if (segments.size() == 0) return ans; 
    ppi now = segments[0]; 

    for (int i = 1; i < segments.size(); ++i){
        ppi seg = segments[i]; 
        if (seg.first.first == now.first.second + 1 && seg.second == now.second)
            now.first.second = seg.first.second; 

        else{
            ans.push_back(now); 
            now = seg; 
        }
    }

    ans.push_back(now); 
    return ans; 
}


void solve(){
    int n; cin >> n; 
    vector<pi> X(n); 
    for (int i = 0; i < n; ++i) cin >> X[i].first >> X[i].second; 
    X.push_back(pi(0, 0)); 
    sort(X.begin(), X.end()); 
    
    int col_now = 0; 
    int ind_X = 0; 

    vector<ppi> segments, next; 
    segments.push_back(ppi(pi(0, 0), 1)); 

    while (true){
        vector<int> bad_now; 
        while (ind_X < X.size() && X[ind_X].first == col_now){
            bad_now.push_back(X[ind_X].second); 
            ind_X++; 
        }

        segments = combine(segments, bad_now); 
        next.clear(); 

        int push = 0; 
        for (ppi seg : segments){
            if (push == 0){
                if (seg.second != 2) next.push_back(ppi(seg.first, 0)); 
                if (seg.second == 2) next.push_back(ppi(seg.first, 1)), push = 1; 
            }
            else if (push == 1){
                if (seg.second == 0) next.push_back(ppi(seg.first, 0)), push = 0; 
                if (seg.second == 1) next.push_back(ppi(seg.first, 1)); 
                if (seg.second == 2) next.push_back(ppi(seg.first, 2)), push = 2; 
            }
            else if (push == 2){
                if (seg.second == 1) next.push_back(ppi(seg.first, 2)); 
                if (seg.second == 2){
                    cout << "NO\n"; 
                    return; 
                }
                if (seg.second == 0){
                    if (seg.first.second == seg.first.first){
                        next.push_back(ppi(seg.first, 1)), push = 1; 
                    }
                    else{
                        next.push_back(ppi(pi(seg.first.first, seg.first.first), 1)); 
                        next.push_back(ppi(pi(seg.first.first + 1, seg.first.second), 0)); 
                        push = 0; 
                    }
                }
            }
            else {
                cout << "NO\n"; 
                return; 
            }
        }

        segments = compress(next); 
        bool cont = false; 
        for (ppi seg : segments) if (seg.second != 0) cont = true; 
        if (!cont) break; 
        col_now++; 
    }

    cout << "YES\n"; 
}


int main(){
    int t; cin >> t; 
    while (t--) solve(); 
}